﻿using System;
using System.Collections.Generic;
using System.DrawingCore;
using System.DrawingCore.Imaging;
using System.Numerics;
using System.Security.Cryptography;
using System.Threading.Tasks;

/*
 * 
 * 
 * 
 *            |
 *            | 
 *            |
 *            |  
 * -----------+-------------> X
 *            |      
 *            |
 *            |
 *            |
 *            ↓
 *            Y
 * * * * * * * * * * * * * * * * * */


namespace Raytracer
{
    class Program
    {
        static void Main(string[] args)
        {
            Transform scene = new Transform(new Vector3(0));
            Camera cam = new Camera(0.006, new Vector2(0.01, 0.01), new Vector2i(512, 512));
            cam.transform.position = new Vector3(0,0,-5);
            Renderer r = new Renderer(scene, 15);
            LightShader light = new LightShader(new Vector3(1));
            LightShader lightA = new LightShader(new Vector3(0.6,0.98,0.12));
            LightShader lightB = new LightShader(new Vector3(0.1, 0.36, 0.89));
            LightShader lightC = new LightShader(new Vector3(0.9, 0.15, 0.25));
            DiffShader R = new DiffShader(new Vector3(236, 187, 206)/255);// 236,187,206
            DiffShader G = new DiffShader(new Vector3(209,241, 192)/255);//209,241,192
            DiffShader B = new DiffShader(new Vector3(149, 223, 240)/255);//149,223,240
            DiffShader W = new DiffShader(new Vector3(1));
            DiffShader C = new DiffShader(new Vector3(0.9));
            MirriorShader mirror = new MirriorShader();

            Mesh tmesh = new Mesh();
            Mesh cube = new Mesh();
            cube.CreateCube(new Vector3(1));

            Mesh cubea = new Mesh();
            cubea.CreateCube(new Vector3(1));

            //tmesh.LoadFromFile(@"I:\Project\CS\RayTracer\RayTracer\testmesh.gmes");

            scene.childen.Add(new InfinityPlane(new Vector3(0, 3, 0), new Vector3(0, -1, 0)).transform);
            scene.childen.Add(new InfinityPlane(new Vector3(0, -3, 0), new Vector3(0, 1, 0)).transform);
            scene.childen.Add(new InfinityPlane(new Vector3(3, 0, 0), new Vector3(-1, 0, 0)).transform);
            scene.childen.Add(new InfinityPlane(new Vector3(-3, 3, 0), new Vector3(1, 0, 0)).transform);
            scene.childen.Add(new InfinityPlane(new Vector3(0, 0, 3), new Vector3(0, 0, -1)).transform);
            scene.childen.Add(new InfinityPlane(new Vector3(0, 0, -10), new Vector3(0, 0, 1)).transform);
            scene.childen.Add(new MeshRenderer(cube).transform);
            scene.childen.Add(new MeshRenderer(cubea).transform);
            scene.childen.Add(new Sphere(new Vector3(1,-0.6,-0.4),0.6).transform);
            #region sucks

            Renderable ra = scene.childen[0].sceneObject as Renderable;
            ra.shader = light;

            ra = scene.childen[1].sceneObject as Renderable;
            ra.shader = R;

            ra = scene.childen[2].sceneObject as Renderable;
            ra.shader = G;

            ra = scene.childen[3].sceneObject as Renderable;
            ra.shader = B;

            ra = scene.childen[4].sceneObject as Renderable;
            ra.shader = W;

            ra = scene.childen[5].sceneObject as Renderable;
            ra.shader = W;
            
            ra = scene.childen[6].sceneObject as Renderable;
            ra.shader = W;
            scene.childen[6].scale = new Vector3(1.5,3.8,1.5);
            scene.childen[6].rotation = Quaternion.CreateFromYawPitchRoll(-0.5f,0f,0);
            scene.childen[6].position = new Vector3(-1.3,-3,0);

            ra = scene.childen[7].sceneObject as Renderable;
            ra.shader = W;
            scene.childen[7].scale = new Vector3(1.4, 1.4, 1.4);
            scene.childen[7].rotation = Quaternion.CreateFromYawPitchRoll(0.3f, 0f, 0);
            scene.childen[7].position = new Vector3(0.3, -3, 0);

            ra = scene.childen[8].sceneObject as Renderable;
            ra.shader = light;

            #endregion
            Bitmap output = r.Render(cam, new RenderProperty(2048, 32));
            output.Save(@"./render.bmp");
            //Console.WriteLine(Environment.CurrentDirectory);
            System.Diagnostics.Process.Start("mspaint.exe", Environment.CurrentDirectory + "\\render.bmp");
        }
    }
}